//TeXworksScript
//Title: Help LaTeX2e 
//Description: Karl Berry's html Help information in a paste-able dialogue
//Author: Paul A. Norman
//Version: 0.551
//Date: 2013-02-18
//Script-Type: standalone
//Context: TeXDocument
//Shortcut: Alt+F1, Alt+2

// was 0.55 Date: 2011-02-01

// eval(TW.app.getGlobal("helper_twPan")); //  Comment if NOT Needed - This includes PhpJs ($P), twConst, msgBox, twPan ($tw), string.toTitleCase()


const twConst = {
                     SystemAccess_OK : 0,

                 SystemAccess_Failed : 1,

       SystemAccess_PermissionDenied : 2

              }; // end twConst
              


/*                

                  Not sure on current status of this ... Tuesday 1st, February, 2011 ...
                  
                  Please Note that QUrl is not currently available for opening TextBrowser documents
                  hence the current strange work-arounds.

                  That is we apparently can not textBrowser.setSource() from QtScript as
                  QUrl is not available to QtScript and is required for textBrowser.setSource()
                  A QtScript string does not directly cast.

                  See http://doc.trolltech.com/4.3/qtscript.html#overloaded-signals-and-slots
                  Specifically  http://doc.trolltech.com/4.3/qtscript.html#conversion-between-qtscript-and-c-types  */

// Global Vars ---

var commandNames = new Array();
var hrefAddresses = new Array();
//lookUpNameAddress = new Array();

/* Was ... as __FILE__ was once the only way to do this... // var baseDir = getPath(__FILE__) ; 2013-02-18
*/
 var baseDir = getPath(TW.script.fileName) ;

 var whereNext;
 var count = 0;
 var found = false;
 var lookForNearMatch = true;
 var showThis = '';
 var holdClipboard = TW.app.clipboard;
         TW.app.setClipboardText('');
 var selText = TW.target.selection;
 var browserSelected = new String("");


 var helpLatex2e; // dialogue Script Object

               /* Longhand approach, could iterate all findChildren over created .ui looking for
                  carefully crafted name prefixes, but this approach keeps widget's QtScript names
                  in plain view for developer's own personal memory needs :-) 
                  
                  Update: it us possible to locate directly but again this make easier long term 
               */

var scriptWidgets = new Array(
                    "btn_Concept", "btn_Commands", "btn_Main", "btn_User",  "menuBrowser", "helpBrowser",
                    "button_Big_List", "button_getTwSelection", "btn_about", "edit_prompt", "nav_forward",
                    "nav_back", "button_pasteSelectionIntoTw"
                              );

/*  Begin Preamble ----------*/

/*               This next loop has to be done in Global space and not in a gerneral function,
                 for Script widget objects, and `in memory functions_()' generated here,
                 to be available generally to script  */

  createDialogue();

for (widget in scriptWidgets)
{
    //           Define helpLatex2e dialogue .ui widgets here in QtScript as programible objects

    eval(scriptWidgets[widget] + " = TW.findChildWidget(helpLatex2e,\"" + scriptWidgets[widget] + "\")");

    /*           functions_() below here are defined in memory,

                 Part of a work around for the `sender' object being malnourished in QtScript
                 and `this' inside an event funciton() not pointing to the widget object's scope,
                 but to the QtScript object space.

                 This approach passes the QtScript object in a widget's own
                 slot event response function to a generic handler function in each case
                 (Makes for cleaner code management and avoids writing and defining of numerous functions.)

                 The 'virtual' functions call `declared' functions,
                           in this case --   processButton and navigateHistory */

    if (scriptWidgets[widget].indexOf('btn_') > -1)
    {
        eval("function " + scriptWidgets[widget]+"_clicked(){processButton("+scriptWidgets[widget]+")}");
    }

    if (scriptWidgets[widget].indexOf('nav_') > -1)
    {
        eval("function " + scriptWidgets[widget]+"_clicked(){navigateHistory("+scriptWidgets[widget]+")}");
    }
  }// /End. for (widget in scriptWidgets)



startHtml = '<br /><h2>&nbsp;&nbsp;Please Wait A Moment ...</h2>'
       if (selText != '')
          {startHtml += '<br />&nbsp; &nbsp;&nbsp; &nbsp;Looking for -- ' + selText;}

helpBrowser.setHtml(startHtml);


/*  End. Preamble ----------*/

// Not available to scripting-- helpBrowser.setDefaultStyleSheet("color:rgb(196,225,178)");
// not available in 4.3 Scripting--  helpBrowser.loadResource(3, 'Help_LaTeX2e_css.css');


// Begin

 setup();

 retVal = helpLatex2e.exec();

    if(retVal == 1) // OK was clicked
    {
       pasteIntoTw();
    }

 finishUp();

null;

// End.

/*  Begin Procedures ----------*/

function UIconnectVarious(connectAction)
{
    /*          This streamlines initialisation and finalisation of the script dialogue
                slot connections connectAction passes either 'connect' or 'dissconect'  */

      // eval("nameofWidget.slotEvent."       +  connectAction  + "(functionYouWriteBelow)");
                                                                     // !make function in Global Space!

    eval("button_Big_List.clicked."       +  connectAction  + "(button_Big_List_clicked)");
    eval("button_getTwSelection.clicked." +  connectAction  + "(button_getTwSelection_clicked)");
    eval("button_pasteSelectionIntoTw.clicked." +  connectAction  + "(pasteIntoTw)")
    eval("edit_prompt.textChanged."       +  connectAction  + "(edit_prompt_changed)");
    eval("menuBrowser['highlighted(QString)']." +  connectAction  + "(menuBrowser_anchorOver)"); // overload
    eval("menuBrowser.anchorClicked."     +  connectAction  + "(menuBrowser_anchorClicked)");
    eval("helpBrowser['highlighted(QString)']." +  connectAction  + "(helpBrowser_anchorOver)"); // overload
    eval("helpBrowser.selectionChanged."  +  connectAction  + "(helpBrowser_selectionChanged)");
    eval("helpBrowser.forwardAvailable."  +  connectAction  + "(helpBrowser_forwardAvailable)");
    eval("helpBrowser.backwardAvailable." + connectAction  + "(helpBrowser_backwardAvailable)");
    eval("helpBrowser.copyAvailable." + connectAction  + "(helpBrowser_copyAvailable)");

 /*              for buttons using generic handlers, functions used in iterations here
                 have been virtually created in memeory (Globally) during findchild()
                 above where var scriptWidgets is declared. */

    for (widget in scriptWidgets)
    {
        if ( (scriptWidgets[widget].indexOf('btn_') > -1) | (scriptWidgets[widget].indexOf('nav_') > -1) )
        {
            eval( scriptWidgets[widget] + ".clicked."	+ connectAction  + "("+scriptWidgets[widget] + "_clicked)");

            /*   functions defined in memory, above, during 'scriptWidget' creation
                 Part of a work around for the 'sender' object being malnourished in QtScript
                 and 'this' within an event functoin not pointing to the widget object's scope,
                 but to the QTScript object space instead. */
        }
    }
}
function alert(txt)
{
    TW.warning(null, "Tw Message", txt );
}

function getPath(fullFileName)
{
    return  fullFileName.substr(0, fullFileName.lastIndexOf("/") +1);
}


function getText(fileName)
{

   var res = TW.readFile(fileName);
                                 switch (res.status)
                                 {
                                   case twConst.SystemAccess_PermissionDenied:
                                   case twConst.SystemAccess_Failed:
  												 this.alert(res.message);
												var text = undefined;
											break;

                                   case twConst.SystemAccess_OK:  												 
												var text = res.result;
											break;
                                  }
       return text;
}

function pasteIntoTw()
{
    if (TW.app.clipboard != "")
    {TW.target.insertText(TW.app.clipboard);
 }
}



function navigate(browserWidget, filePath)
{//   wrapped this in case we get script access to QUrl and can change things here

/*
 tried looking for every concieveable cast here with all kinds of myUrl array object string object etc ..
    browserWidget.setSource(myUrl);
Always get---
``TypeError: incompatible type of argument(s) in call to setSource(); candidates were
    setSource(QUrl)
        browserWidget.setSource(filePath);
*/

browserWidget.setHtml(getText(filePath));

}

function processButton(Button)
{
  navigate(helpBrowser, baseDir  + Button.toolTip);
  // as of 0.52 directory is included in toolTip

}

function button_getTwSelection_clicked()
{
    currentSelection = TW.target.selection.toString();
    edit_prompt.text = currentSelection.substr(0,4);

for (item=0; item< commandNames.length; item++) // re-set help information if locatable
  {
   if (commandNames[item].toLowerCase() == currentSelection.toLowerCase())
    {
        showThis =  hrefAddresses[item];
        menuBrowser_anchorClicked(showThis);
        break;
    }
  }
}

function edit_prompt_changed()
{

    var  buildHTML ='';
    var  spanHighlight = '<span style="color: green; font-weight: bold;">';
    var  closeSpan = '</span>';
    var  thisHref ='';
    var  editPromptText = edit_prompt.text.toString();

      editPromptText = editPromptText.replace(/\\/g,"\\\\"); // can't have \ leading a regualr expression

    //   editPromptText = editPromptText.replace('\\','');


    var  findThis = new RegExp(editPromptText, "ig");
    editPromptText = edit_prompt.text  ; // restore for genreal use

    for (item=0; item < commandNames.length; item++)
    {
       var displayText = commandNames[item];

       if (commandNames[item].toString() == editPromptText)
        {
          thisHref = hrefAddresses[item]; // show exact match information
          displayText = '<span style="font-size: large">' + displayText + '</span>';
        }

       if ( (commandNames[item].toString().toLowerCase().indexOf(editPromptText.toLowerCase()) > -1)
          &
           (commandNames[item].toString() != "") )
        {           

                displayText = displayText.replace(findThis ,spanHighlight + editPromptText + closeSpan);

            buildHTML += '<a href=\"'+hrefAddresses[item]+'\">'+displayText+'</a><br />';
        }

    }

    if (buildHTML =='')
       {
        buildHTML = "<b>Nothing found - please try altering your search.</b>";
        }
    menuBrowser.setHtml(buildHTML);

    if (thisHref != '')
    {
        menuBrowser_anchorClicked(thisHref); // show exact match information
    }

}

/* function helpBrowser_historyChanged()
{
    nav_forward.enabled = helpBrowser.isForwardAvailable();
       nav_back.enabled = helpBrowser.isBackwardAvailable()
}  Works but not officially listed in Qt 4.3 version, better avoid it. isBackwardAvailable() might nnot be available*/

function helpBrowser_forwardAvailable(response)
{
    nav_forward.enabled = response;
}

function helpBrowser_backwardAvailable(response)
{
    nav_back.enabled = response;
}

function helpBrowser_anchorOver(text)
{
    helpBrowser.toolTip = text;
}

function menuBrowser_anchorOver(text)
{
    menuBrowser.toolTip = text;
}

function helpBrowser_copyAvailable(canDo)
{
  button_pasteSelectionIntoTw.enabled = canDo;
}

function helpBrowser_selectionChanged(sender)
{

     /* QT 4.3 ( - 4.6 ?) Scripting not supporting--

      selectionObj = helpBrowser.textCursor();
      text =  selectionObj.selectedText();

    Use this and clipboard routines...
    */
    helpBrowser.copy();
}

function navigateHistory(navWhich)
{
    switch(navWhich.objectName)
    {

    case "nav_forward":
          helpBrowser.forward();
        break;

    case "nav_back":
          helpBrowser.backward();
        break;

    default:
    }
}

function menuBrowser_anchorClicked(url)
{
    var Anchor = '';
    var FindWholeWords = 0x00004 ;

     showThis = url.toString();
    if( showThis.indexOf('#') > -1)
    {
        Anchor = showThis.substr(showThis.indexOf('#') +1 );
        showThis = showThis.substr(0, showThis.indexOf('#') );
    }

    navigate(helpBrowser, baseDir + 'html/' + showThis)

   // Workaround for not being able to use QUrl in setting browser.source
   if (Anchor != '')
           {
             helpBrowser.scrollToAnchor(Anchor);
            }

   // Not Supported in Qt 4.3 Scripting-- helpBrowser.find(showThis.substr(0,showThis.indexOf('.htm')),FindWholeWords);
}


function button_Big_List_clicked()
{
    chosenCommand =  TW.getItem( null, "Please Chose A Command", "Choose A Command", commandNames , 0 , false ) ;


    if (chosenCommand != undefined)
        for (item in commandNames)
        {
            if (chosenCommand == commandNames[item])
            {
                showThis = hrefAddresses[item];
                menuBrowser_anchorClicked(showThis);
                break;
            }
        }

}

function createDialogue()
{
/*
var uiXML = getText(baseDir + "helpLatex2e.ui");
    uiXML = uiXML.replace('set Search Path in createDialogue()', baseDir + 'html');  // set search paths, can not be done in script after dialogue opens

// Global
helpLatex2e = TW.createUIFromString(uiXML);
*/

//Thanks Stefan Loefer

helpLatex2e = TW.createUI(baseDir + "helpLatex2e.ui");

TW.findChildWidget(helpLatex2e, "helpBrowser").searchPaths = [baseDir + 'html'];
}

function makeReady()
{
if (selText == undefined)
{selText = '';}

 /*
 Leave user to choose \ prefix as their are help infos environemts for e.g. that dont start with \
 if (selText.substr(0,1) != '\\')
  {selText = '\\'+selText;}
 */
        commandNames.push("Type Into Box Below");
        hrefAddresses.push("about.html");

html = getText(baseDir + 'user/Tw_User_Help_Index.html');
buildMenu(html);

html = getText(baseDir + 'html/Tw_Commands.html');
buildMenu(html);

html = getText(baseDir + 'html/Tw_Concept-Index.html');
buildMenu(html);

for (item=0; item< commandNames.length; item++) // set initial help information if locatable
{
    if ((commandNames[item].substr(0,3) == selText.substr(0,3)) & (lookForNearMatch))
    {count = item;
        lookForNearMatch = false;}

    if (commandNames[item].toLowerCase() == selText.toLowerCase())
    {
        showThis =  hrefAddresses[item];
        found = true;
    }
}

if(! found) // we are NOT finished
{
  /*

//Was going to present drop down box with available commnands if selected text blank, or not locatable in commandNames, however thought this could be tedious for frequent users.

//Instead setting a bit of any selected text in the prompt box for filtering command names:-
//                        edit_prompt.text = selText.substr(0,3);

chosenCommand =  TW.getItem( null, "Please Chose A Command", "Choose A Command", commandNames  , count , false ) ; //hrefAddresses


    if (chosenCommand != undefined)
        for (item in commandNames)
        {
        if (chosenCommand == commandNames[item])
        {
            count = item;
            break;
        }
    }

    showThis = hrefAddresses[count];
    */

   showThis = 'about.html';
}

/*

 menuBrowser_anchorClicked(url) handles this better--
if( showThis.indexOf('#') > -1)
{
    showThis = showThis.substr(0, showThis.indexOf('#') );
}
*/
   url =  showThis;

/* We can not textBrowser.setSource() from QtScript
   QUrl is not available to QtScript and is required for textBrowser.setSource()
   A QtScript string does not directly cast, perhaps some other sort of object will?
   So Any way ...                           */

   // helpBrowser.setHtml(getText(url));  menuBrowser_anchorClicked(url) handles this better--

   menuBrowser_anchorClicked(url);
   edit_prompt.text = selText.substr(0,4);
} // /End. function makeReady{}

function buildMenu(html)
{
remainingChunk = html;
whereNext = remainingChunk.indexOf('<li><a');
processThis =  remainingChunk.substr(whereNext);



while (whereNext != -1)
{
    anchorStart = processThis.indexOf('href=\"') + 6;
    hrefEnd = processThis.indexOf('\">') ;

    href = processThis.substr(anchorStart,hrefEnd - anchorStart);

    displayTextStart = processThis.indexOf('\">') +2;
    displayTextEnd = processThis.indexOf('</a');
    displayText = processThis.substr(displayTextStart, (displayTextEnd - displayTextStart));

    var useThis = true;

//for (item in commandNames)
  for (item =0; item < commandNames.length; item++)// avoid duplicates
      // item =0; ..., faster than:  for (item in commandNames) ... About 25% faster!
    {
        if ( commandNames[item] == displayText ) //.toLowerCase()
        {
            useThis = false;
            break;
        }
        // /End.  if (commandNames[item]==displayText)
    }// /End.  for (item in commandNames)

    if(useThis == true)
    {
        commandNames.push(displayText);
        hrefAddresses.push(href);
    }

    //lookUpNameAddress[displayText] =  href;

    whereNext = remainingChunk.substr(displayTextEnd +1 ).indexOf('<li><a'); // move along
    remainingChunk = remainingChunk.substr(whereNext);
    processThis = remainingChunk;

 } // /End. while (whereNext != -1)

}

function setup()
{
 makeReady();

// Initialisation

UIconnectVarious('connect'); // Set up event listening

edit_prompt_changed();  // initialises left hand menu
}

function finishUp()
{
// Finalisation

// De-commission event listening
UIconnectVarious('disconnect');

// replace any contents on clipboard.
TW.app.setClipboardText(holdClipboard);
}
/*  End. Procedures ----------*/

 /*
  Dual licensed under the

GPL (http://www.gnu.org/licenses/old-licenses/gpl-2.0.html)
http://www.gnu.org/licenses/old-licenses/gpl-2.0.html

Copyright (c) 2010,2011 Paul A Norman and others in their own right


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

MIT (http://www.opensource.org/licenses/mit-license.php)

Copyright (c) 2010,2011 Paul A Norman and others in their own right

 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal in the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL PAUL ANTHONY NORMAN BE LIABLE FOR ANY CLAIM, DAMAGES
 OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN EITHER THE SOFTWARE OR DOCUMENTATION.

*/ 
